--- old/usr/src/pkgdefs/SUNWdcar/preremove	Tue Oct 28 16:45:59 2008
+++ new/usr/src/pkgdefs/SUNWdcar/preremove	Tue Oct 28 16:45:58 2008
@@ -21,19 +21,16 @@
 #
 
 #
-# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
+
 #
-#
 # Preremove script for SUNWdcar.
 #
-# This script removes the hardware provider section for the dca
-# driver from /etc/crypto/kcf.conf
+# This script removes the driver with rem_drv(1M) if necessary.
 #
 DRV=dca
-
 NAMEMAJOR="${BASEDIR}/etc/name_to_major"
 
 #
@@ -54,54 +51,4 @@
     ${REM_DRV} ${DRV} || exit 1
 fi
 
-pkg_start="# Start $PKGINST"
-pkg_end="# End $PKGINST"
-kcfconf=${BASEDIR}/etc/crypto/kcf.conf
-tmpfile=/tmp/$$kcfconf
-error=no
-
-#
-# If /etc/crypto/kcf.conf doesn't exist, bail immediately
-#
-if [ ! -f "$kcfconf" ]
-then
-	echo "$0: ERROR - $kcfconf doesn't exist"
-	exit 2
-fi
-
-#
-# Strip all entries belonging to this package
-#
-start=0
-end=0
-egrep -s "$pkg_start" $kcfconf && start=1
-egrep -s "$pkg_end" $kcfconf && end=1
-
-if [ $start -ne $end ] ; then
-	echo "$0: missing Start or End delimiters for $PKGINST in $kcfconf."
-	echo "$0: $kcfconf may be corrupted and was not updated."
-	error=yes
-	exit 2
-fi
-
-if [ $start -eq 1 ]
-then
-	# To preserve the gid
-	cp -p $kcfconf $tmpfile
-	sed -e "/$pkg_start/,/$pkg_end/d" $kcfconf > $tmpfile || error=yes
-	if [ "$error" = no ]
-	then 
-		mv $tmpfile $kcfconf || error=yes
-	fi
-	rm -f $tmpfile
-else
-	echo "$0: WARNING - no entries to be removed from $kcfconf" 
-	exit 0
-fi
-
-if [ "$error" = yes ]
-then
-	echo "$0: ERROR - failed to update $kcfconf."
-	exit 2
-fi
 exit 0
--- old/usr/src/pkgdefs/SUNWn2cp.v/postinstall	Tue Oct 28 16:46:03 2008
+++ new/usr/src/pkgdefs/SUNWn2cp.v/postinstall	Tue Oct 28 16:46:02 2008
@@ -21,11 +21,9 @@
 #
 
 #
-# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 #
 # install the UltraSPARC-T2 Crypto Provider device driver
@@ -33,72 +31,6 @@
 
 PATH="/usr/bin:/usr/sbin:${PATH}"
 export PATH
-
-# Add hardware provider section for the n2cp driver
-# to /etc/crypto/kcf.conf
-
-pkg_start="# Start $PKGINST"
-pkg_end="# End $PKGINST"
-kcfconf=${BASEDIR}/etc/crypto/kcf.conf
-tmpfile=/tmp/$$kcfconf
-error=no
-
-#
-# If /etc/crypto/kcf.conf doesn't exist, bail immediately
-#
-if [ ! -f "$kcfconf" ]
-then
-	echo "$0: ERROR - $kcfconf doesn't exist"
-        exit 2
-fi
-
-#
-# If the package has been already installed, remove old entries
-#
-start=0
-end=0
-egrep -s "$pkg_start" $kcfconf && start=1
-egrep -s "$pkg_end" $kcfconf && end=1
-
-if [ $start -ne $end ] ; then
-	echo "$0: missing Start or End delimiters for $PKGINST in $kcfconf."
-	echo "$0: $kcfconf may be corrupted and was not updated."
-	error=yes
-	exit 2
-fi
-
-if [ $start -eq 1 ]
-then
-	cp -p $kcfconf $tmpfile || error=yes
-	sed -e "/$pkg_start/,/$pkg_end/d" $kcfconf > $tmpfile || error=yes
-else
-	cp -p $kcfconf $tmpfile || error=yes
-fi
-
-#
-# Append the delimiters for this package
-#
-echo "$pkg_start driver_names=n2cp" >> $tmpfile || error=yes
-echo "$pkg_end" >> $tmpfile || error=yes
-
-#
-# Install the updated config file and clean up the tmp file
-#
-if [ "$error" = no ]
-then
-	mv $tmpfile $kcfconf || error=yes
-fi
-rm -f $tmpfile
-
-#
-# All done, if any of the steps above fail, report the error
-#
-if [ "$error" = yes ]
-then
-	echo "$0: ERROR - failed to update $kcfconf."
-        exit 2
-fi
-
 NAMEMAJOR="${BASEDIR}/etc/name_to_major"
 
 if [ "${BASEDIR:=/}" = "/" ]
--- old/usr/src/pkgdefs/SUNWn2cp.v/preremove	Tue Oct 28 16:46:11 2008
+++ new/usr/src/pkgdefs/SUNWn2cp.v/preremove	Tue Oct 28 16:46:07 2008
@@ -21,19 +21,16 @@
 #
 
 #
-# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
+
 #
-#
 # Preremove script for SUNWn2cp.v.
 #
-# This script removes the hardware provider section for the n2cp
-# driver from /etc/crypto/kcf.conf
+# This script removes driver with rem_drv(1M) if necessary.
 #
 DRV=n2cp
-
 NAMEMAJOR="${BASEDIR}/etc/name_to_major"
 
 #
@@ -54,52 +51,4 @@
     ${REM_DRV} ${DRV} || exit 1
 fi
 
-pkg_start="# Start $PKGINST"
-pkg_end="# End $PKGINST"
-kcfconf=${BASEDIR}/etc/crypto/kcf.conf
-tmpfile=/tmp/$$kcfconf
-error=no
-
-#
-# If /etc/crypto/kcf.conf doesn't exist, bail immediately
-#
-if [ ! -f "$kcfconf" ]
-then
-	echo "$0: ERROR - $kcfconf doesn't exist"
-	exit 2
-fi
-
-#
-# Strip all entries belonging to this package
-#
-start=0
-end=0
-egrep -s "$pkg_start" $kcfconf && start=1
-egrep -s "$pkg_end" $kcfconf && end=1
-
-if [ $start -ne $end ] ; then
-	echo "$0: missing Start or End delimiters for $PKGINST in $kcfconf."
-	echo "$0: $kcfconf may be corrupted and was not updated."
-	error=yes
-	exit 2
-fi
-
-if [ $start -eq 1 ]
-then
-	cp -p $kcfconf $tmpfile || error=yes
-	sed -e "/$pkg_start/,/$pkg_end/d" $kcfconf > $tmpfile || error=yes
-	if [ "$error" = no ]
-	then 
-		mv $tmpfile $kcfconf || error=yes
-	fi
-	rm -f $tmpfile
-else
-	exit 0
-fi
-
-if [ "$error" = yes ]
-then
-	echo "$0: ERROR - failed to update $kcfconf."
-	exit 2
-fi
 exit 0
--- old/usr/src/uts/common/crypto/core/kcf_cryptoadm.c	Tue Oct 28 16:46:19 2008
+++ new/usr/src/uts/common/crypto/core/kcf_cryptoadm.c	Tue Oct 28 16:46:18 2008
@@ -23,8 +23,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
  * Core KCF (Kernel Cryptographic Framework). This file implements
  * the cryptoadm entry points.
@@ -48,9 +46,13 @@
 kmutex_t soft_config_mutex;
 
 /*
- * This linked list contains software configuration entries that
- * are loaded into the kernel by the CRYPTO_LOAD_SOFT_CONFIG ioctl.
- * It is protected by the soft_config_mutex.
+ * This linked list contains software configuration entries.
+ * The initial list is just software providers loaded by kcf_soft_config_init().
+ * Additional entries may appear for both hardware and software providers
+ * from kcf.conf.  These come from "cryptoadm start", which reads file kcf.conf
+ * and updates this table using the CRYPTO_LOAD_SOFT_CONFIG ioctl.
+ * Further cryptoadm commands modify this file and update this table with ioctl.
+ * This list is protected by the soft_config_mutex.
  */
 kcf_soft_conf_entry_t *soft_config_list;
 
@@ -61,17 +63,190 @@
 
 #define	KCF_MAX_CONFIG_ENTRIES 512 /* maximum entries in soft_config_list */
 
+#if DEBUG
+extern int kcf_frmwrk_debug;
+static void kcf_soft_config_dump(char *message);
+#endif /* DEBUG */
+
+/*
+ * Count and return the number of mechanisms in an array of crypto_mech_name_t
+ * (excluding final NUL-character string element).
+ */
+static int
+count_mechanisms(crypto_mech_name_t mechs[]) {
+	int	count;
+	for (count = 0; mechs[count][0] != '\0'; ++count);
+	return (count);
+}
+
+/*
+ * Initialize a mutex and populate soft_config_list with default entries
+ * of kernel software providers.
+ * Called from kcf module _init().
+ */
 void
 kcf_soft_config_init(void)
 {
+	typedef struct {
+		char			*name;
+		crypto_mech_name_t	*mechs;
+	} initial_soft_config_entry_t;
+
+	/*
+	 * This provides initial default values to soft_config_list.
+	 * It is equivalent to these lines in /etc/crypto/kcf.conf
+	 * (without line breaks and indenting):
+	 *
+	 * # /etc/crypto/kcf.conf
+	 * des:supportedlist=CKM_DES_CBC,CKM_DES_ECB,CKM_DES3_CBC,CKM_DES3_ECB
+	 * aes:supportedlist=CKM_AES_ECB,CKM_AES_CBC,CKM_AES_CTR,CKM_AES_CCM
+	 * arcfour:supportedlist=CKM_RC4
+	 * blowfish:supportedlist=CKM_BLOWFISH_ECB,CKM_BLOWFISH_CBC
+	 * ecc:supportedlist=CKM_EC_KEY_PAIR_GEN,CKM_ECDH1_DERIVE,CKM_ECDSA,\
+	 * CKM_ECDSA_SHA1
+	 * sha1:supportedlist=CKM_SHA_1,CKM_SHA_1_HMAC_GENERAL,CKM_SHA_1_HMAC
+	 * sha2:supportedlist=CKM_SHA256,CKM_SHA256_HMAC,
+	 * CKM_SHA256_HMAC_GENERAL,CKM_SHA384,CKM_SHA384_HMAC,\
+	 * CKM_SHA384_HMAC_GENERAL,CKM_SHA512,CKM_SHA512_HMAC,\
+	 * CKM_SHA512_HMAC_GENERAL
+	 * md4:supportedlist=CKM_MD4
+	 * md5:supportedlist=CKM_MD5,CKM_MD5_HMAC_GENERAL,CKM_MD5_HMAC
+	 * rsa:supportedlist=CKM_RSA_PKCS,CKM_RSA_X_509,CKM_MD5_RSA_PKCS,\
+	 * CKM_SHA1_RSA_PKCS,CKM_SHA256_RSA_PKCS,CKM_SHA384_RSA_PKCS,\
+	 * CKM_SHA512_RSA_PKCS
+	 * swrand:supportedlist=random
+	 *
+	 * WARNING: If you add a new kernel crypto provider or mechanism,
+	 * you must update these constants.
+	 *
+	 * 1. To add a new mechanism to a provider add the string to the
+	 * appropriate array below.
+	 *
+	 * 2. To add a new provider, create a new *_mechs array listing the
+	 * provider's mechanism(s).  For example:
+	 *	sha3_mechs[SHA3_MECH_COUNT] = {"CKM_SHA_3"};
+	 * Add the new *_mechs array to initial_soft_config_entry[].
+	 */
+	static crypto_mech_name_t	des_mechs[] = {
+	    "CKM_DES_CBC", "CKM_DES_ECB", "CKM_DES3_CBC", "CKM_DES3_ECB", ""};
+	static crypto_mech_name_t	aes_mechs[] = {
+	    "CKM_AES_ECB", "CKM_AES_CBC", "CKM_AES_CTR", "CKM_AES_CCM", ""};
+	static crypto_mech_name_t 	arcfour_mechs[] = {
+	    "CKM_RC4", ""};
+	static crypto_mech_name_t	blowfish_mechs[] = {
+	    "CKM_BLOWFISH_ECB", "CKM_BLOWFISH_CBC", ""};
+	static crypto_mech_name_t	ecc_mechs[] = {
+	    "CKM_EC_KEY_PAIR_GEN", "CKM_ECDH1_DERIVE", "CKM_ECDSA",
+	    "CKM_ECDSA_SHA1", ""};
+	static crypto_mech_name_t	sha1_mechs[] = {
+	    "CKM_SHA_1", "CKM_SHA_1_HMAC_GENERAL", "CKM_SHA_1_HMAC", ""};
+	static crypto_mech_name_t	sha2_mechs[] = {
+	    "CKM_SHA256", "CKM_SHA256_HMAC", "CKM_SHA256_HMAC_GENERAL",
+	    "CKM_SHA384", "CKM_SHA384_HMAC", "CKM_SHA384_HMAC_GENERAL",
+	    "CKM_SHA512", "CKM_SHA512_HMAC", "CKM_SHA512_HMAC_GENERAL", ""};
+	static crypto_mech_name_t	md4_mechs[] = {
+	    "CKM_MD4", ""};
+	static crypto_mech_name_t	md5_mechs[] = {
+	    "CKM_MD5", "CKM_MD5_HMAC_GENERAL", "CKM_MD5_HMAC", ""};
+	static crypto_mech_name_t	rsa_mechs[] = {
+	    "CKM_RSA_PKCS", "CKM_RSA_X_509", "CKM_MD5_RSA_PKCS",
+	    "CKM_SHA1_RSA_PKCS", "CKM_SHA256_RSA_PKCS", "CKM_SHA384_RSA_PKCS",
+	    "CKM_SHA512_RSA_PKCS", ""};
+	static crypto_mech_name_t	swrand_mechs[] = {
+	    "random", NULL};
+	static initial_soft_config_entry_t
+	    initial_soft_config_entry[] = {
+		"des", des_mechs,
+		"aes", aes_mechs,
+		"arcfour", arcfour_mechs,
+		"blowfish", blowfish_mechs,
+		"ecc", ecc_mechs,
+		"sha1", sha1_mechs,
+		"sha2", sha2_mechs,
+		"md4", md4_mechs,
+		"md5", md5_mechs,
+		"rsa", rsa_mechs,
+		"swrand", swrand_mechs
+	};
+	const int	initial_soft_config_entries =
+	    sizeof (initial_soft_config_entry)
+	    / sizeof (initial_soft_config_entry_t);
+	int		i;
+
 	mutex_init(&soft_config_mutex, NULL, MUTEX_DRIVER, NULL);
+
+	/*
+	 * Initialize soft_config_list with default providers.
+	 * Populate the linked list backwards so the first entry appears first.
+	 */
+	for (i = initial_soft_config_entries - 1; i >= 0; --i) {
+		initial_soft_config_entry_t *p = &initial_soft_config_entry[i];
+		crypto_mech_name_t	*mechsp;
+		char			*namep;
+		uint_t			namelen, alloc_size;
+		int			mech_count, r;
+
+		/* allocate/initialize memory for name and mechanism list */
+		namelen = strlen(p->name) + 1;
+		namep = kmem_alloc(namelen, KM_SLEEP);
+		(void) strlcpy(namep, p->name, namelen);
+		mech_count = count_mechanisms(p->mechs);
+		alloc_size = mech_count * CRYPTO_MAX_MECH_NAME;
+		mechsp = kmem_alloc(alloc_size, KM_SLEEP);
+		bcopy(p->mechs, mechsp, alloc_size);
+
+		r = add_soft_config(namep, mech_count, mechsp);
+		if (r != 0)
+			cmn_err(CE_WARN,
+			    "add_soft_config(%s) failed; returned %d\n",
+			    namep, r);
+	}
+#if DEBUG
+	if (kcf_frmwrk_debug >= 1)
+		kcf_soft_config_dump("kcf_soft_config_init");
+#endif /* DEBUG */
 }
 
 
+#if DEBUG
 /*
+ * Dump soft_config_list, containing a list of kernel software providers
+ * and (optionally) hardware providers, with updates from kcf.conf.
+ * Dump mechanism lists too if kcf_frmwrk_debug is >= 2.
+ */
+static void
+kcf_soft_config_dump(char *message)
+{
+	kcf_soft_conf_entry_t	*p;
+	uint_t			i;
+
+	mutex_enter(&soft_config_mutex);
+	printf("Soft provider config list soft_config_list: %s\n",
+	    message != NULL ? message : "");
+
+	for (p = soft_config_list; p != NULL; p = p->ce_next) {
+		printf("ce_name: %s, %d ce_mechs\n", p->ce_name, p->ce_count);
+		if (kcf_frmwrk_debug >= 2) {
+			printf("\tce_mechs: ");
+			for (i = 0; i < p->ce_count; i++) {
+				printf("%s ", p->ce_mechs[i]);
+			}
+			printf("\n");
+		}
+	}
+	printf("(end of soft_config_list)\n");
+
+	mutex_exit(&soft_config_mutex);
+}
+#endif /* DEBUG */
+
+
+/*
  * Utility routine to identify the providers to filter out and
  * present only one provider. This happens when a hardware provider
  * registers multiple units of the same device instance.
+ *
+ * Called from crypto_get_dev_list().
  */
 static void
 filter_providers(uint_t count, kcf_provider_desc_t **provider_array,
@@ -103,7 +278,11 @@
 }
 
 
-/* called from the CRYPTO_GET_DEV_LIST ioctl */
+/*
+ * Return a list of kernel hardware providers and a count of each
+ * provider's supported mechanisms.
+ * Called from the CRYPTO_GET_DEV_LIST ioctl.
+ */
 int
 crypto_get_dev_list(uint_t *count, crypto_dev_list_entry_t **array)
 {
@@ -119,7 +298,7 @@
 	 * Take snapshot of provider table returning only hardware providers
 	 * that are in a usable state. Logical providers not included.
 	 */
-	rval =  kcf_get_hw_prov_tab(&provider_count, &provider_array, KM_SLEEP,
+	rval = kcf_get_hw_prov_tab(&provider_count, &provider_array, KM_SLEEP,
 	    NULL, 0, B_FALSE);
 	if (rval != CRYPTO_SUCCESS)
 		return (rval);
@@ -161,9 +340,9 @@
 }
 
 /*
- * Called from the CRYPTO_GET_SOFT_LIST ioctl, this routine returns
- * a buffer containing the null terminated names of software providers
+ * Return a buffer containing the null terminated names of software providers
  * loaded by CRYPTO_LOAD_SOFT_CONFIG.
+ * Called from the CRYPTO_GET_SOFT_LIST ioctl.
  */
 int
 crypto_get_soft_list(uint_t *count, char **array, size_t *len)
@@ -225,6 +404,10 @@
 	return (CRYPTO_SUCCESS);
 }
 
+/*
+ * Check if a mechanism name is already in a mechanism name array
+ * Called by crypto_get_dev_info().
+ */
 static boolean_t
 duplicate(char *name, crypto_mech_name_t *array, int count)
 {
@@ -238,7 +421,11 @@
 	return (B_FALSE);
 }
 
-/* called from the CRYPTO_GET_DEV_INFO ioctl */
+/*
+ * Return a list of kernel hardware providers for a given name and instance.
+ * For each entry, also return a list of their supported mechanisms.
+ * Called from the CRYPTO_GET_DEV_INFO ioctl.
+ */
 int
 crypto_get_dev_info(char *name, uint_t instance, uint_t *count,
     crypto_mech_name_t **array)
@@ -256,7 +443,7 @@
 	 * Logical providers not included. NULL name matches
 	 * all hardware providers.
 	 */
-	rv =  kcf_get_hw_prov_tab(&provider_count, &provider_array, KM_SLEEP,
+	rv = kcf_get_hw_prov_tab(&provider_count, &provider_array, KM_SLEEP,
 	    name, instance, B_FALSE);
 	if (rv != CRYPTO_SUCCESS)
 		return (rv);
@@ -311,7 +498,11 @@
 	return (CRYPTO_SUCCESS);
 }
 
-/* called from the CRYPTO_GET_SOFT_INFO ioctl */
+/*
+ * Given a kernel software provider name, return a list of mechanisms
+ * it supports.
+ * Called from the CRYPTO_GET_SOFT_INFO ioctl.
+ */
 int
 crypto_get_soft_info(caddr_t name, uint_t *count, crypto_mech_name_t **array)
 {
@@ -321,29 +512,25 @@
 
 	provider = kcf_prov_tab_lookup_by_name(name);
 	if (provider == NULL) {
-		if (in_soft_config_list(name)) {
-			char *tmp;
-			int name_len;
+		char *tmp;
+		int name_len;
 
-			/* strlen("crypto/") + NULL terminator == 8 */
-			name_len = strlen(name);
-			tmp = kmem_alloc(name_len + 8, KM_SLEEP);
-			bcopy("crypto/", tmp, 7);
-			bcopy(name, &tmp[7], name_len);
-			tmp[name_len + 7] = '\0';
+		/* strlen("crypto/") + NULL terminator == 8 */
+		name_len = strlen(name);
+		tmp = kmem_alloc(name_len + 8, KM_SLEEP);
+		bcopy("crypto/", tmp, 7);
+		bcopy(name, &tmp[7], name_len);
+		tmp[name_len + 7] = '\0';
 
-			modh = ddi_modopen(tmp, KRTLD_MODE_FIRST, NULL);
-			kmem_free(tmp, name_len + 8);
+		modh = ddi_modopen(tmp, KRTLD_MODE_FIRST, NULL);
+		kmem_free(tmp, name_len + 8);
 
-			if (modh == NULL) {
-				return (CRYPTO_ARGUMENTS_BAD);
-			}
+		if (modh == NULL) {
+			return (CRYPTO_ARGUMENTS_BAD);
+		}
 
-			provider = kcf_prov_tab_lookup_by_name(name);
-			if (provider == NULL) {
-				return (CRYPTO_ARGUMENTS_BAD);
-			}
-		} else {
+		provider = kcf_prov_tab_lookup_by_name(name);
+		if (provider == NULL) {
 			return (CRYPTO_ARGUMENTS_BAD);
 		}
 	}
@@ -355,6 +542,13 @@
 	return (rv);
 }
 
+
+/*
+ * Change the mechanism list for a provider.
+ * If "direction" is CRYPTO_MECH_ADDED, add new mechanisms.
+ * If "direction" is CRYPTO_MECH_REMOVED, remove the mechanism list.
+ * Called from crypto_load_dev_disabled().
+ */
 static void
 kcf_change_mechs(kcf_provider_desc_t *provider, uint_t count,
     crypto_mech_name_t *array, crypto_event_change_t direction)
@@ -463,7 +657,7 @@
 	 * Get provider table entries matching name and instance
 	 * for providers that are are in a usable or unverified state.
 	 */
-	rv =  kcf_get_hw_prov_tab(&provider_count, &provider_array, KM_SLEEP,
+	rv = kcf_get_hw_prov_tab(&provider_count, &provider_array, KM_SLEEP,
 	    name, instance, B_TRUE);
 	if (rv != CRYPTO_SUCCESS)
 		return (rv);
@@ -561,7 +755,7 @@
 		 * This check assumes that enable and disable are separate
 		 * administrative actions and are not done in a single action.
 		 */
-		if (new_count < prev_count && (in_soft_config_list(name)) &&
+		if ((new_count < prev_count) &&
 		    (modload("crypto", name) != -1)) {
 			struct modctl *mcp;
 			boolean_t load_again = B_FALSE;
@@ -590,7 +784,10 @@
 	return (add_soft_config(name, count, array));
 }
 
-/* called from the CRYPTO_UNLOAD_SOFT_MODULE ioctl */
+/*
+ * Unload a kernel software crypto module.
+ * Called from the CRYPTO_UNLOAD_SOFT_MODULE ioctl.
+ */
 int
 crypto_unload_soft_module(caddr_t name)
 {
@@ -623,11 +820,14 @@
 	return (CRYPTO_SUCCESS);
 }
 
-/* called from CRYPTO_GET_DEV_LIST ioctl */
+/*
+ * Free the list of kernel hardware crypto providers.
+ * Called by get_dev_list() for the CRYPTO_GET_DEV_LIST ioctl.
+ */
 void
 crypto_free_dev_list(crypto_dev_list_entry_t *array, uint_t count)
 {
-	if (count ==  0 || array == NULL)
+	if (count == 0 || array == NULL)
 		return;
 
 	kmem_free(array, count * sizeof (crypto_dev_list_entry_t));
@@ -813,6 +1013,10 @@
 	return (CRYPTO_SUCCESS);
 }
 
+/*
+ * Free memory for elements in a kcf_soft_config_entry_t.  This entry must
+ * have been previously removed from the soft_config_list linked list.
+ */
 static void
 free_soft_config_entry(kcf_soft_conf_entry_t *p)
 {
@@ -822,14 +1026,18 @@
 }
 
 /*
- * Called from the CRYPTO_LOAD_SOFT_CONFIG ioctl, this routine stores
- * configuration information for software providers in a linked list.
+ * Store configuration information for software providers in a linked list.
  * If the list already contains an entry for the specified provider
  * and the specified mechanism list has at least one mechanism, then
  * the mechanism list for the provider is updated. If the mechanism list
  * is empty, the entry for the provider is removed.
  *
- * Important note: the array argument is consumed.
+ * Called from kcf_soft_config_init() (to initially populate the list
+ * with default kernel providers) and from crypto_load_soft_config() for
+ * the CRYPTO_LOAD_SOFT_CONFIG ioctl (for third-party kernel modules).
+ *
+ * Important note: the name and array arguments must be allocated memory
+ * and are consumed in soft_config_list.
  */
 static int
 add_soft_config(char *name, uint_t count, crypto_mech_name_t *array)
@@ -881,7 +1089,7 @@
 		soft_config_list = new_entry;
 		soft_config_count++;
 		entry = new_entry;
-	} else {
+	} else { /* mechanism already in list */
 		kmem_free(new_entry->ce_name, name_len);
 		kmem_free(new_entry, sizeof (kcf_soft_conf_entry_t));
 	}
@@ -950,25 +1158,4 @@
 	*name = kmem_alloc(name_len, KM_SLEEP);
 	bcopy(tmp_name, *name, name_len);
 	return (CRYPTO_SUCCESS);
-}
-
-/*
- * This routine searches the soft_config_list for the specified
- * software provider, returning B_TRUE if it is in the list.
- */
-boolean_t
-in_soft_config_list(char *provider_name)
-{
-	kcf_soft_conf_entry_t *p;
-	boolean_t rv = B_FALSE;
-
-	mutex_enter(&soft_config_mutex);
-	for (p = soft_config_list; p != NULL; p = p->ce_next) {
-		if (strcmp(provider_name, p->ce_name) == 0) {
-			rv = B_TRUE;
-			break;
-		}
-	}
-	mutex_exit(&soft_config_mutex);
-	return (rv);
 }
--- old/usr/src/uts/common/crypto/core/kcf_prov_tabs.c	Tue Oct 28 16:46:24 2008
+++ new/usr/src/uts/common/crypto/core/kcf_prov_tabs.c	Tue Oct 28 16:46:23 2008
@@ -19,12 +19,10 @@
  * CDDL HEADER END
  */
 /*
- * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
  * This file is part of the core Kernel Cryptographic Framework.
  * It implements the management of tables of Providers. Entries to
@@ -54,19 +52,33 @@
 
 #define	KCF_MAX_PROVIDERS	512	/* max number of providers */
 
-static kmutex_t prov_tab_mutex; /* ensure exclusive access to the table */
+/*
+ * Prov_tab is an array of providers which is updated when
+ * a crypto provider registers with kcf. The provider calls the
+ * SPI routine, crypto_register_provider(), which in turn calls
+ * kcf_prov_tab_add_provider().
+ *
+ * A provider unregisters by calling crypto_unregister_provider()
+ * which triggers the removal of the prov_tab entry.
+ * It also calls kcf_remove_mech_provider().
+ *
+ * prov_tab entries are not updated from kcf.conf or by cryptoadm(1M).
+ */
 static kcf_provider_desc_t **prov_tab = NULL;
+static kmutex_t prov_tab_mutex; /* ensure exclusive access to the table */
 static uint_t prov_tab_num = 0; /* number of providers in table */
 static uint_t prov_tab_max = KCF_MAX_PROVIDERS;
 
 #if DEBUG
 extern int kcf_frmwrk_debug;
-static void kcf_prov_tab_dump(void);
+static void kcf_prov_tab_dump(char *message);
 #endif /* DEBUG */
 
+
 /*
- * Initialize the providers table. The providers table is dynamically
- * allocated with prov_tab_max entries.
+ * Initialize a mutex and the KCF providers table, prov_tab.
+ * The providers table is dynamically allocated with prov_tab_max entries.
+ * Called from kcf module _init().
  */
 void
 kcf_prov_tab_init(void)
@@ -124,7 +136,7 @@
 
 #if DEBUG
 	if (kcf_frmwrk_debug >= 1)
-		kcf_prov_tab_dump();
+		kcf_prov_tab_dump("kcf_prov_tab_add_provider");
 #endif /* DEBUG */
 
 	return (CRYPTO_SUCCESS);
@@ -170,7 +182,7 @@
 
 #if DEBUG
 	if (kcf_frmwrk_debug >= 1)
-		kcf_prov_tab_dump();
+		kcf_prov_tab_dump("kcf_prov_tab_rem_provider");
 #endif /* DEBUG */
 
 	return (CRYPTO_SUCCESS);
@@ -817,21 +829,34 @@
 }
 
 #if DEBUG
-
+/*
+ * Dump the Kernel crypto providers table, prov_tab.
+ * If kcf_frmwrk_debug is >=2, also dump the mechanism lists.
+ */
 static void
-kcf_prov_tab_dump(void)
+kcf_prov_tab_dump(char *message)
 {
-	uint_t i;
+	uint_t i, j;
 
 	mutex_enter(&prov_tab_mutex);
+	printf("Providers table prov_tab at %s:\n",
+	    message != NULL ? message : "");
 
-	printf("Providers table:\n");
 	for (i = 0; i < KCF_MAX_PROVIDERS; i++) {
-		if (prov_tab[i] != NULL) {
-			printf("[%d]: (%s) %s\n",
-			    i, (prov_tab[i]->pd_prov_type ==
-			    CRYPTO_HW_PROVIDER) ? "HW" : "SW",
-			    prov_tab[i]->pd_description);
+		kcf_provider_desc_t *p = prov_tab[i];
+		if (p != NULL) {
+			printf("[%d]: (%s) %d mechanisms, %s\n", i,
+			    (p->pd_prov_type == CRYPTO_HW_PROVIDER) ?
+			    "HW" : "SW",
+			    p->pd_mech_list_count, p->pd_description);
+			if (kcf_frmwrk_debug >= 2) {
+				printf("\tpd_mechanisms: ");
+				for (j = 0; j < p->pd_mech_list_count; ++j) {
+					printf("%s \n",
+					    p->pd_mechanisms[j].cm_mech_name);
+				}
+				printf("\n");
+			}
 		}
 	}
 	printf("(end of providers table)\n");
